dsdpschurmat_impl.h File Reference

Function pointers that a Schur complement matrix (dense, sparse, parallel dense) must provide. More...

Go to the source code of this file.

## Functions

int | DSDPSchurMatOpsInitialize (struct DSDPSchurMat_Ops *)
| Initialize function pointers to 0.
int | DSDPSetSchurMatOps (DSDP, struct DSDPSchurMat_Ops *, void *)
| Set the Schur complement matrix.
int | DSDPSparsityInSchurMat (DSDP, int, int[], int)
| Identify nonzero elements in a row of the Schur complement.

## Detailed Description

Function pointers that a Schur complement matrix (dense, sparse, parallel dense) must provide.

Definition in file dsdpschurmat_impl.h.

## Function Documentation

## DSDPSchurMatOpsInitialize()

int DSDPSchurMatOpsInitialize | ( | struct DSDPSchurMat_Ops * | dops | ) |

extern

Initialize function pointers to 0.

Parameters

  dops | address of a structure of function pointers.

Definition at line 44 of file dsdpschurmat.c.

Referenced by DSDPSchurMatDestroy(), and DSDPSchurMatInitialize().

## DSDPSetSchurMatOps()

int DSDPSetSchurMatOps | ( | DSDP | dsdp,
|  | struct DSDPSchurMat_Ops * | sops,
|  | void * | mdata
| ) |  |

extern

Set the Schur complement matrix.

Parameters

  dsdp | the solver
  sops | address of a structure with function pointers
  mdata | address of a matrix object

The step direction in DSDP is the solution to a set of linear equations. The cones used by DSDP compute the elements of the matrix and the right-hand side vectors. Any matrix that implements the Schur complement matrix interface can be used by DSDP. In addition to factoring a matrix and solving it, this interface also provides matrix assembly routines for the cones.

See also
  DSDPAddCone()

Todo:
  Use SCALAPACK to assemble, factor, and solve the matrix in parallel.

Definition at line 602 of file dsdpcops.c.

## DSDPSparsityInSchurMat()

int DSDPSparsityInSchurMat | ( | DSDP | dsdp,
|  | int | row,
|  | int | rnnz[],
|  | int | mm
| ) |  |

extern

Identify nonzero elements in a row of the Schur complement.

Parameters

  dsdp | solver
  row | corresponding to variable y.
  rnnz | array to be marked nonzero if nonzero.
  mm | dimension of M matrix

Definition at line 649 of file dsdpschurmat.c.